/* Copyright (c) 2015 Nordic Semiconductor. All Rights Reserved.
 *
 * The information contained herein is property of Nordic Semiconductor ASA.
 * Terms and conditions of usage are described in detail in NORDIC
 * SEMICONDUCTOR STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information. NO
 * WARRANTY of ANY KIND is provided. This heading must NOT be removed from
 * the file.
 *
 */

/**
 * @brief    UART over BLE application main file.
 *
 * This file contains the source code for a sample server application using the LED Button service.
 */

#include "include.h"

#include "nrf_dfu_svci.h"
#include "nrf_svci_async_function.h"
#include "nrf_svci_async_handler.h"

#include "nordic_common.h"
#include "app_error.h"
#include "ble.h"
#include "ble_hci.h"
#include "ble_srv_common.h"
#include "ble_advdata.h"
#include "ble_advertising.h"
#include "ble_conn_params.h"
#include "nrf_sdh.h"
#include "nrf_sdh_soc.h"
#include "nrf_sdh_ble.h"
#include "nrf_ble_gatt.h"
#include "app_timer.h"
#include "app_button.h"
#include "nrf_drv_clock.h"

#if MOTION_SENSOR_TYPE == MOTION_SENSOR_TYPE_9X_ACCEL_GYRO_MAG
#include "app_mpu9250.h"
#endif

//#include "74hc595.h"
//#include "app_74hc595.h"

#include "nrf_fstorage.h"
#include "fds.h"

#include "peer_manager.h"
#include "app_uart.h"
#include "app_util_platform.h"
//#include "bsp_btn_ble.h"
#include "twi_master.h"
#include "nrf_delay.h"

#include "nrf_fstorage.h"
#include "ble_dfu.h"
#include "ble_nus.h"
#include "ble_conn_state.h"
//#include "led.h"
#include "rotation.h"
#include "Timer.h"
#include "button.h"
#include "uart_api.h"
#include "beep.h"
#include "ADC.h"
#include "power.h"
#include "wireless.h"
#include "InnerFlash.h"
//#include "cubecell.h"
//#include "trackGam.h"
//#include "SSRS.h"
#include "nrf_drv_rng.h"
#include "nrf_pwr_mgmt.h"

#define NRF_LOG_MODULE_NAME "APP"
#if defined (UART_PRESENT)
#include "nrf_uart.h"
#endif
#if defined (UARTE_PRESENT)
#include "nrf_uarte.h"
#endif

#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"

#define APP_BLE_CONN_CFG_TAG            1                                           /**< A tag identifying the SoftDevice BLE configuration. */

#define APP_FEATURE_NOT_SUPPORTED       BLE_GATT_STATUS_ATTERR_APP_BEGIN + 2        /**< Reply when unsupported features are requested. */

#define NUS_SERVICE_UUID_TYPE           BLE_UUID_TYPE_VENDOR_BEGIN                  /**< UUID type for the Nordic UART Service (vendor specific). */

#define APP_BLE_OBSERVER_PRIO           3                                           /**< Application's BLE observer priority. You shouldn't need to modify this value. */
#define APP_ADV_INTERVAL_HIGH           80                                          /**< The advertising interval (in units of 0.625 ms. This value corresponds to 50 ms). */
#define APP_ADV_INTERVAL_LOW            1200                                        /**< 3150 The advertising interval (in units of 0.625 ms. This value corresponds to 2000 ms). */
#define APP_ADV_TIMEOUT_IN_SECONDS      0      			    			    		/**< The advertising timeout (in units of seconds). */

#define MIN_CONN_INTERVAL_HIGH               MSEC_TO_UNITS(11, UNIT_1_25_MS)             /**< 11 Minimum acceptable connection interval (25 microseconds). */
#define MAX_CONN_INTERVAL_HIGH               MSEC_TO_UNITS(64, UNIT_1_25_MS)             /**< 1875 Maximum acceptable connection interval (62.5 microsecond). */
#define SLAVE_LATENCY                   0                                           /**< Slave latency. */
#define CONN_SUP_TIMEOUT                MSEC_TO_UNITS(4000, UNIT_10_MS)             /**< Connection supervisory time-out (4 seconds). */

#define FIRST_CONN_PARAMS_UPDATE_DELAY  APP_TIMER_TICKS(5000)                       /**< Time from initiating event (connect or start of notification) to first time sd_ble_gap_conn_param_update is called (5 seconds). */
#define NEXT_CONN_PARAMS_UPDATE_DELAY   APP_TIMER_TICKS(30000)                      /**< Time between each call to sd_ble_gap_conn_param_update after the first call (30 seconds). */
#define MAX_CONN_PARAMS_UPDATE_COUNT    3                                           /**< Number of attempts before giving up the connection parameter negotiation. */

#define TX_POWER_LEVEL                  (0)                                         /**< TX Power Level value. This will be set both in the TX Power service, in the advertising data, and also used to set the radio transmit power. */
#define TX_POWER_LEVEL_LOW              (-12)                                         /**< TX Power Level value. This will be set both in the TX Power service, in the advertising data, and also used to set the radio transmit power. */

#define DEAD_BEEF                       0xDEADBEEF                                  /**< Value used as error code on stack dump, can be used to identify stack location on stack unwind. */


BLE_NUS_DEF(m_nus);                                                                 /**< BLE NUS service instance. */
NRF_BLE_GATT_DEF(m_gatt);                                                           /**< GATT module instance. */
BLE_ADVERTISING_DEF(m_advertising);                                                 /**< Advertising module instance. */
static uint16_t                         m_conn_handle = BLE_CONN_HANDLE_INVALID;    /**< Handle of the current connection. */
static uint16_t                         m_ble_nus_max_data_len = BLE_GATT_ATT_MTU_DEFAULT - 3;  /**< Maximum length of data (in bytes) that can be transmitted to the peer by the Nordic UART service module. */
static ble_uuid_t                       m_adv_uuids[] = {	
															{BLE_UUID_NUS_SERVICE, NUS_SERVICE_UUID_TYPE}
															};  /**< Universally unique service identifier. */



typedef enum
{
	SEC_ADV_INTERVAL_MODE_MIN = 0,
	SEC_ADV_INTERVAL_MODE_LOW = APP_ADV_INTERVAL_LOW,
	SEC_ADV_INTERVAL_MODE_HIGH = APP_ADV_INTERVAL_HIGH,
	SEC_ADV_INTERVAL_MODE_MAX
}SEC_ADV_INTERVAL_MODE_ENUM;		//BLE通信广播时间间隔模式
															
volatile SEC_ADV_INTERVAL_MODE_ENUM g_adv_interval_mode = SEC_ADV_INTERVAL_MODE_LOW;	//默认BLE广播低速模式

bool erase_bonds = false;
static void check_adv_mode_on_connect(void);
static void check_adv_mode_on_disconnect(void);
void advertising_start(bool erase_bonds);

/**@brief Callback function for asserts in the SoftDevice.
 *
 * @details This function will be called in case of an assert in the SoftDevice.
 *
 * @warning This handler is an example only and does not fit a final product. You need to analyse
 *          how your product is supposed to react in case of Assert.
 * @warning On assert from the SoftDevice, the system can  only recover on reset.
 *
 * @param[in] line_num    Line number of the failing ASSERT call.
 * @param[in] p_file_name File name of the failing ASSERT call.
 */
void assert_nrf_callback(uint16_t line_num, const uint8_t * p_file_name)
{
    app_error_handler(DEAD_BEEF, line_num, p_file_name);
}

/**@brief Function for the power ctl pins initialization.
 *
 * @details Initializes power ctl pins used by the application.
 */
static void pwr_init(void)
{
    nrf_gpio_cfg_output(PWR_3V3_EN_PIN);//配置P0.17为输出
    nrf_gpio_pin_set(PWR_3V3_EN_PIN);   //指示灯D1初始状态为熄灭
}

static uint32_t set_min_max_conn_interval(void)
{
    uint32_t                err_code;
    ble_gap_conn_params_t   gap_conn_params;
	
    memset(&gap_conn_params, 0, sizeof(gap_conn_params));


	gap_conn_params.min_conn_interval = MIN_CONN_INTERVAL_HIGH;
	gap_conn_params.max_conn_interval = MAX_CONN_INTERVAL_HIGH;

    gap_conn_params.slave_latency     = SLAVE_LATENCY;
    gap_conn_params.conn_sup_timeout  = CONN_SUP_TIMEOUT;

    err_code = sd_ble_gap_ppcp_set(&gap_conn_params);
    APP_ERROR_CHECK(err_code);
	
	return err_code;
}

void set_ble_tx_power_high(void)
{
    uint32_t                err_code;
	
	err_code = sd_ble_gap_tx_power_set(TX_POWER_LEVEL);
	APP_ERROR_CHECK(err_code);
}

void set_ble_tx_power_low(void)
{
    uint32_t                err_code;
	
	err_code = sd_ble_gap_tx_power_set(TX_POWER_LEVEL_LOW);
	APP_ERROR_CHECK(err_code);
}

/**@brief Function for the GAP initialization.
 *
 * @details This function will set up all the necessary GAP (Generic Access Profile) parameters of
 *          the device. It also sets the permissions and appearance.
 */
static void gap_params_init(void)
{
    uint32_t                err_code;
    ble_gap_conn_sec_mode_t sec_mode;
	uint8_t DEVICE_NAME_STR[24] = "";
	
	sprintf((char *)DEVICE_NAME_STR, "%s_%s_%X", DEVICE_NAME_BASE, DEVICE_VERSION, (u32)(0x00FFFFFFUL&NRF_FICR->DEVICEADDR[0]));

    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&sec_mode);

    err_code = sd_ble_gap_device_name_set(&sec_mode,
                                          (const uint8_t *) DEVICE_NAME_STR,
                                          strlen((const char *)DEVICE_NAME_STR));
    APP_ERROR_CHECK(err_code);

    /* YOUR_JOB: Use an appearance value matching the application's use case.
       err_code = sd_ble_gap_appearance_set(BLE_APPEARANCE_);
       APP_ERROR_CHECK(err_code); */

	err_code = set_min_max_conn_interval();
	APP_ERROR_CHECK(err_code);
										  
	set_ble_tx_power_high();
}


/**@brief Function for handling the data from the Nordic UART Service.
 *
 * @details This function will process the data received from the Nordic UART BLE Service and send
 *          it to the UART module.
 *
 * @param[in] p_nus    Nordic UART Service structure.
 * @param[in] p_data   Data to be send to UART module.
 * @param[in] length   Length of the data.
 */
/**@snippet [Handling the data received over BLE] */
static void nus_data_handler(ble_nus_evt_t * p_evt)
{
    if (p_evt->type == BLE_NUS_EVT_RX_DATA)
    {
		//ble_nus_string_send(&m_nus, (uint8_t *)p_evt->params.rx_data.p_data, &p_evt->params.rx_data.length);
		detectDataFromBLE((uint8_t *)(p_evt->params.rx_data.p_data), p_evt->params.rx_data.length);
	}
}
/**@snippet [Handling the data received over BLE] */


/**@brief Function for initializing services that will be used by the application.
 */
static void services_init(void)
{
    uint32_t       err_code;
    ble_nus_init_t nus_init;

    memset(&nus_init, 0, sizeof(nus_init));

    nus_init.data_handler = nus_data_handler;

    err_code = ble_nus_init(&m_nus, &nus_init);
    APP_ERROR_CHECK(err_code);

}


/**@brief Function for handling an event from the Connection Parameters Module.
 *
 * @details This function will be called for all events in the Connection Parameters Module
 *          which are passed to the application.
 *
 * @note All this function does is to disconnect. This could have been done by simply setting
 *       the disconnect_on_fail config parameter, but instead we use the event handler
 *       mechanism to demonstrate its use.
 *
 * @param[in] p_evt  Event received from the Connection Parameters Module.
 */
static void on_conn_params_evt(ble_conn_params_evt_t * p_evt)
{
    uint32_t err_code;

    if (p_evt->evt_type == BLE_CONN_PARAMS_EVT_FAILED)
    {
        err_code = sd_ble_gap_disconnect(m_conn_handle, BLE_HCI_CONN_INTERVAL_UNACCEPTABLE);
        APP_ERROR_CHECK(err_code);
    }
}


/**@brief Function for handling a Connection Parameters error.
 *
 * @param[in] nrf_error  Error code containing information about what went wrong.
 */
static void conn_params_error_handler(uint32_t nrf_error)
{
    APP_ERROR_HANDLER(nrf_error);
}


/**@brief Function for initializing the Connection Parameters module.
 */
static void conn_params_init(void)
{
    uint32_t               err_code;
    ble_conn_params_init_t cp_init;

    memset(&cp_init, 0, sizeof(cp_init));

    cp_init.p_conn_params                  = NULL;
    cp_init.first_conn_params_update_delay = FIRST_CONN_PARAMS_UPDATE_DELAY;
    cp_init.next_conn_params_update_delay  = NEXT_CONN_PARAMS_UPDATE_DELAY;
    cp_init.max_conn_params_update_count   = MAX_CONN_PARAMS_UPDATE_COUNT;
    cp_init.start_on_notify_cccd_handle    = BLE_GATT_HANDLE_INVALID;
    cp_init.disconnect_on_fail             = false;
    cp_init.evt_handler                    = on_conn_params_evt;
    cp_init.error_handler                  = conn_params_error_handler;

    err_code = ble_conn_params_init(&cp_init);
    APP_ERROR_CHECK(err_code);
}


/**@brief Function for putting the chip into sleep mode.
 *
 * @note This function will not return.
 */
void sleep_mode_enter(void)
{
    uint32_t err_code;
	//err_code = bsp_indication_set(BSP_INDICATE_IDLE);
    //APP_ERROR_CHECK(err_code);

    // Prepare wakeup buttons.
    //err_code = bsp_btn_ble_sleep_mode_prepare();
    //APP_ERROR_CHECK(err_code);

    // Go to system-off mode (this function will not return; wakeup will cause a reset).
    err_code = sd_power_system_off();
    APP_ERROR_CHECK(err_code);
}


/**@brief Function for handling advertising events.
 *
 * @details This function will be called for advertising events which are passed to the application.
 *
 * @param[in] ble_adv_evt  Advertising event.
 */
static void on_adv_evt(ble_adv_evt_t ble_adv_evt)
{
    //uint32_t err_code;

    switch (ble_adv_evt)
    {
        case BLE_ADV_EVT_FAST:
            //err_code = bsp_indication_set(BSP_INDICATE_ADVERTISING);
            //APP_ERROR_CHECK(err_code);
            break;
        case BLE_ADV_EVT_IDLE:
            sleep_mode_enter();
            break;
        default:
            break;
    }
}


/**@brief Function for handling BLE events.
 *
 * @param[in]   p_ble_evt   Bluetooth stack event.
 * @param[in]   p_context   Unused.
 */
static void ble_evt_handler(ble_evt_t const * p_ble_evt, void * p_context)
{
    uint32_t err_code = NRF_SUCCESS;

    switch (p_ble_evt->header.evt_id)
    {
        case BLE_GAP_EVT_CONNECTED:
            //err_code = bsp_indication_set(BSP_INDICATE_CONNECTED);
            //APP_ERROR_CHECK(err_code);
            m_conn_handle = p_ble_evt->evt.gap_evt.conn_handle;
			check_adv_mode_on_connect();
			
            break; // BLE_GAP_EVT_CONNECTED

        case BLE_GAP_EVT_DISCONNECTED:
            //err_code = bsp_indication_set(BSP_INDICATE_IDLE);
            //APP_ERROR_CHECK(err_code);
            m_conn_handle = BLE_CONN_HANDLE_INVALID;
			check_adv_mode_on_disconnect();
		    wireless_connected_Flag = false;
            break; // BLE_GAP_EVT_DISCONNECTED
		
#ifndef S140
        case BLE_GAP_EVT_PHY_UPDATE_REQUEST:
        {
            NRF_LOG_DEBUG("PHY update request.");
            ble_gap_phys_t const phys =
            {
                .rx_phys = BLE_GAP_PHY_AUTO,
                .tx_phys = BLE_GAP_PHY_AUTO,
            };
            err_code = sd_ble_gap_phy_update(p_ble_evt->evt.gap_evt.conn_handle, &phys);
            APP_ERROR_CHECK(err_code);
        } break;
#endif

        case BLE_GAP_EVT_SEC_PARAMS_REQUEST:
            // Pairing not supported
            err_code = sd_ble_gap_sec_params_reply(m_conn_handle, BLE_GAP_SEC_STATUS_PAIRING_NOT_SUPP, NULL, NULL);
            APP_ERROR_CHECK(err_code);
            break;
#if !defined (S112)
         case BLE_GAP_EVT_DATA_LENGTH_UPDATE_REQUEST:
        {
            ble_gap_data_length_params_t dl_params; 

            // Clearing the struct will effectivly set members to @ref BLE_GAP_DATA_LENGTH_AUTO
            memset(&dl_params, 0, sizeof(ble_gap_data_length_params_t));
            err_code = sd_ble_gap_data_length_update(p_ble_evt->evt.gap_evt.conn_handle, &dl_params, NULL);
            APP_ERROR_CHECK(err_code);
        } break;
#endif //!defined (S112)
        case BLE_GATTS_EVT_SYS_ATTR_MISSING:
            // No system attributes have been stored.
            err_code = sd_ble_gatts_sys_attr_set(m_conn_handle, NULL, 0, 0);
            APP_ERROR_CHECK(err_code);
            break;

        case BLE_GATTC_EVT_TIMEOUT:
            // Disconnect on GATT Client timeout event.
            err_code = sd_ble_gap_disconnect(p_ble_evt->evt.gattc_evt.conn_handle,
                                             BLE_HCI_REMOTE_USER_TERMINATED_CONNECTION);
            APP_ERROR_CHECK(err_code);
            break;

        case BLE_GATTS_EVT_TIMEOUT:
            // Disconnect on GATT Server timeout event.
            err_code = sd_ble_gap_disconnect(p_ble_evt->evt.gatts_evt.conn_handle,
                                             BLE_HCI_REMOTE_USER_TERMINATED_CONNECTION);
            APP_ERROR_CHECK(err_code);
            break;

        case BLE_EVT_USER_MEM_REQUEST:
            err_code = sd_ble_user_mem_reply(p_ble_evt->evt.gattc_evt.conn_handle, NULL);
            APP_ERROR_CHECK(err_code);
            break;

        case BLE_GATTS_EVT_RW_AUTHORIZE_REQUEST:
        {
            ble_gatts_evt_rw_authorize_request_t  req;
            ble_gatts_rw_authorize_reply_params_t auth_reply;

            req = p_ble_evt->evt.gatts_evt.params.authorize_request;

            if (req.type != BLE_GATTS_AUTHORIZE_TYPE_INVALID)
            {
                if ((req.request.write.op == BLE_GATTS_OP_PREP_WRITE_REQ)     ||
                    (req.request.write.op == BLE_GATTS_OP_EXEC_WRITE_REQ_NOW) ||
                    (req.request.write.op == BLE_GATTS_OP_EXEC_WRITE_REQ_CANCEL))
                {
                    if (req.type == BLE_GATTS_AUTHORIZE_TYPE_WRITE)
                    {
                        auth_reply.type = BLE_GATTS_AUTHORIZE_TYPE_WRITE;
                    }
                    else
                    {
                        auth_reply.type = BLE_GATTS_AUTHORIZE_TYPE_READ;
                    }
                    auth_reply.params.write.gatt_status = APP_FEATURE_NOT_SUPPORTED;
                    err_code = sd_ble_gatts_rw_authorize_reply(p_ble_evt->evt.gatts_evt.conn_handle,
                                                               &auth_reply);
                    APP_ERROR_CHECK(err_code);
                }
            }
        } break; // BLE_GATTS_EVT_RW_AUTHORIZE_REQUEST

        default:
            // No implementation needed.
            break;
    }
}

/**@brief Function for initializing the BLE stack.
 *
 * @details Initializes the SoftDevice and the BLE event interrupt.
 */
static void ble_stack_init(void)
{
    ret_code_t err_code;

    err_code = nrf_sdh_enable_request();
    APP_ERROR_CHECK(err_code);

    // Configure the BLE stack using the default settings.
    // Fetch the start address of the application RAM.
    uint32_t ram_start = 0;
    err_code = nrf_sdh_ble_default_cfg_set(APP_BLE_CONN_CFG_TAG, &ram_start);
    APP_ERROR_CHECK(err_code);

    // Enable BLE stack.
    err_code = nrf_sdh_ble_enable(&ram_start);
    APP_ERROR_CHECK(err_code);

    NRF_SDH_BLE_OBSERVER(m_ble_observer, APP_BLE_OBSERVER_PRIO, ble_evt_handler, NULL);
}


/**@brief Function for handling events from the GATT library. */
void gatt_evt_handler(nrf_ble_gatt_t * p_gatt, nrf_ble_gatt_evt_t const * p_evt)
{
    if ((m_conn_handle == p_evt->conn_handle) && (p_evt->evt_id == NRF_BLE_GATT_EVT_ATT_MTU_UPDATED))
    {
        m_ble_nus_max_data_len = p_evt->params.att_mtu_effective - OPCODE_LENGTH - HANDLE_LENGTH;
        //NRF_LOG_INFO("Data len is set to 0x%X(%d)\r\n", m_ble_nus_max_data_len, m_ble_nus_max_data_len);
		if(m_ble_nus_max_data_len)
		{
		}
    }
    //NRF_LOG_DEBUG("ATT MTU exchange completed. central 0x%x peripheral 0x%x\r\n", p_gatt->att_mtu_desired_central, p_gatt->att_mtu_desired_periph);
}

/**@brief Function for initializing the GATT library. */
void gatt_init(void)
{
    ret_code_t err_code;

    err_code = nrf_ble_gatt_init(&m_gatt, gatt_evt_handler);
    APP_ERROR_CHECK(err_code);

    err_code = nrf_ble_gatt_att_mtu_periph_set(&m_gatt, 64);
    APP_ERROR_CHECK(err_code);
}

void advertising_error_handler(uint32_t nrf_error)
{
	uint32_t local_error = nrf_error;
	if(local_error)
	{
	}
}

/**@brief Function for initializing the Advertising functionality.
 */
static void advertising_init(void)
{
    uint32_t               err_code;
    ble_advertising_init_t init;

    memset(&init, 0, sizeof(init));

	init.error_handler = advertising_error_handler;
	
    init.advdata.name_type          = BLE_ADVDATA_FULL_NAME;
    init.advdata.include_appearance = false;
    init.advdata.flags              = BLE_GAP_ADV_FLAGS_LE_ONLY_GENERAL_DISC_MODE;

    init.srdata.uuids_complete.uuid_cnt = sizeof(m_adv_uuids) / sizeof(m_adv_uuids[0]);
    init.srdata.uuids_complete.p_uuids  = m_adv_uuids;

    init.config.ble_adv_slow_enabled  = true;
	init.config.ble_adv_slow_interval = g_adv_interval_mode;
    init.config.ble_adv_slow_timeout  = APP_ADV_TIMEOUT_IN_SECONDS;

    init.evt_handler = on_adv_evt;

    err_code = ble_advertising_init(&m_advertising, &init);
    APP_ERROR_CHECK(err_code);


    ble_advertising_conn_cfg_tag_set(&m_advertising, APP_BLE_CONN_CFG_TAG);
}

static void check_adv_mode_on_connect(void)
{
	ble_adv_modes_config_t p_adv_modes_config;
	
	if(SEC_ADV_INTERVAL_MODE_LOW == g_adv_interval_mode)//连接时检测到当前为低速模式
	{
		//重新广播后切换到高速模式，需重新连接
		g_adv_interval_mode = SEC_ADV_INTERVAL_MODE_HIGH;
		
		p_adv_modes_config.ble_adv_fast_enabled = true;
		p_adv_modes_config.ble_adv_fast_interval = g_adv_interval_mode;
		p_adv_modes_config.ble_adv_fast_timeout = APP_ADV_TIMEOUT_IN_SECONDS;
		
		ble_advertising_modes_config_set(&m_advertising, &p_adv_modes_config);
	}
	else
	{
	}
	wireless_connected_Flag = true;
	
	//停止残留的断开超时减速定时器
	stop_callback_timer(CB_TIMER_ID_BLEADVTIMEOUT);
}

	/*
//断开无线连接超时处理
static void disconnect_switch_adv_mode_timeout_cb(u16 timer_id, u16 times_count)
{	
	//切换到低速模式，长期待机
	g_adv_interval_mode = SEC_ADV_INTERVAL_MODE_LOW;
		
	sd_ble_gap_adv_stop();
	advertising_init();
	advertising_start(true);
}
	*/

static void check_adv_mode_on_disconnect(void)
{
	/*
	//advertising_start(true);
	if(SEC_ADV_INTERVAL_MODE_HIGH == g_adv_interval_mode)//断开连接时当前为高速速模式
	{
		//开启定时回调,30s后切换回低速模式
		start_callback_timer(30, CB_TIMER_ID_BLEADVTIMEOUT, CB_TIMER_TYPE_Many, 1, disconnect_switch_adv_mode_timeout_cb);
	}
	*/
}


/**@brief Function for starting advertising.
 */
void advertising_start(bool erase_bonds)
{
    //if (erase_bonds == true)
    {
    //    delete_bonds();
        // Advertising is started by PM_EVT_PEERS_DELETE_SUCCEEDED event.
    }
    //else
    {
        uint32_t err_code = ble_advertising_start(&m_advertising, BLE_ADV_MODE_FAST);
        APP_ERROR_CHECK(err_code);

        //NRF_LOG_DEBUG("advertising is started");
    }
}

/**@brief Function for stopping advertising.
 */
void disconnect_all_ble_connections(void)
{
	uint32_t err_code = 0;
	
	err_code = sd_ble_gap_disconnect(m_conn_handle, BLE_HCI_CONN_INTERVAL_UNACCEPTABLE);
	APP_ERROR_CHECK(err_code);
}

/**@brief Function for starting advertising.
 */
void advertising_stop(void)
{
	uint32_t err_code = 0;
	
	err_code = sd_ble_gap_adv_stop();
	APP_ERROR_CHECK(err_code);
}

/**@brief Function for placing the application in low power state while waiting for events.
 */
static void power_manage(void)
{
    uint32_t err_code = sd_app_evt_wait();
    APP_ERROR_CHECK(err_code);
}

/**@brief Function for application main entry.
 */
int main(void)
{
	//ret_code_t err_code;
	keep_RAM_retention();
	init_power_mode();
	init_log_queue();
	disAllowSystemOff();
	init_general_button();
	//detect_bootup_key_status();

	//err_code = NRF_LOG_INIT(NULL);
	// Initialize.
	timers_init();
	init_callback_timers();
    //uart_init();

	
//	cycle_detect_leds_delay_task();	//do on leds for start up
		
	//ble init 
    ble_stack_init();
    gap_params_init();
    gatt_init();
    services_init();
    advertising_init();
    conn_params_init();

	
	init_InnerFlash();
	//Init rotation pins
	init_rotation_gpio();
	init_general_button_queue();
	
//	init_beep();

	//init timers
	init_public_timer();
	
	//init adc
	ADC1_Configuration();
	
#if MOTION_SENSOR_TYPE == MOTION_SENSOR_TYPE_9X_ACCEL_GYRO_MAG
	//init of mpu9050 steps
	init_motion_sensor();
#endif	
    // Start execute timers.
	application_timers_start();
	
	//Start advertising BLE wireless service
    advertising_start(erase_bonds);

	//--------------------------	
	enable_public_timer();

//	cycle_detect_leds_delay_task();	//do off leds for start up

//	start_BroadBootWelcomeVoice_timer();
//	check_adv_mode_on_disconnect();
	
	
    // Enter main loop.
    for (;;)
    {
        power_manage();
    }
}


/*********************************************end of file*********************************************/
